﻿#pragma once

#include "DLLCallback.h"

using namespace System;
using namespace System::Runtime::InteropServices;

namespace CLRCallbackWrapper {

	public delegate void LOAD_SYSTEM_COMPLETE_CSHARP_CB(int);

	public ref class CallbackWrapper
	{
	public:
		CallbackWrapper()
		{
			m_pDllWrapper = new DLLWrapper();
		}
		virtual ~CallbackWrapper()
		{
			if (m_pDllWrapper)
			{
				delete m_pDllWrapper;
				m_pDllWrapper = NULL;
			}
		}

		bool registerCallbackFunc(LOAD_SYSTEM_COMPLETE_CSHARP_CB^ callbackFromCSharp, int a, int b);
		void deleteCallbackFunc();

		void callFuncCB();

	private:
		DLLWrapper* m_pDllWrapper;
		LOAD_SYSTEM_COMPLETE_CSHARP_CB^ m_callback;
	};
}
